
class EntityProxy {
	private Entity @me;
	void construct(Entity@ e) { @me = @e; }

	float message(int msg, Entity@ e, vec2 v)
	{
		float ret = -1;
		switch (msg) {
			case EM_INIT: return init();
			case EM_TICK: return tick();
			case EM_ARRIVED: return arrived();
			case EM_GAINED_SIGHT: return gainedSight(e);
			case EM_LOST_SIGHT: return lostSight(e);
			case EM_GAINED_RANGE: return gainedRange(e);
			case EM_LOST_RANGE: return lostRange(e);
			case EM_USER_MOVETO: return userMoveTo(v);
			case EM_USER_MOVETO_QUEUE: return userMoveToQueue(v);
		}
		return ret;
	}
	
	//defaults do nothing, schedule next tick for 1 second
	float init() { return 1; }
	float tick() { return 1; }
	float arrived() { return 1; }
	float gainedSight(Entity@ e) { return 1; }
	float lostSight(Entity@ e) { return 1; }
	float gainedRange(Entity@ e) { return 1; }
	float lostRange(Entity@ e) { return 1; }
	float userMoveTo(vec2) { return 1; }
	float userMoveToQueue(vec2) { return 1; }
	
	//all functions below just use the inner Entity
	string getName() { return me.getName(); }
	
	void setColor(color3 c) { me.setColor(c); }	
	void setLabel(string s) { me.setLabel(s); }
	
	vec2 getPos() { return me.getPos(); }
	vec2 getVel() { return me.getVel(); }
	
	void setVel(vec2 v) { me.setVel(v); }
	float moveTo(vec2 v) { return me.moveTo(v); }
	float moveToQueue(vec2 v) { return me.moveToQueue(v); }
	float getETA(vec2 v) { return me.getETA(v); }
	void setSpeed(float s) { me.setSpeed(s); }
	void setSpacing(float s) { me.setSpacing(s); }
	
	void fireAt(vec2 v) { me.fireAt(v); }
	void ceaseFire() { me.ceaseFire(); }
	
	Entity@[] getVisibleEnemies() { return me.getVisibleEnemies(); }
	
	float getHitpoints() { return me.getHitpoints(); }
	float getMaxVel() { return me.getMaxVel(); }
	float getVisibilityRange() { return me.getVisibilityRange(); }
	float getAttackRange() { return me.getAttackRange(); }
	float getBulletSpeed() { return me.getBulletSpeed(); }
	float getBlastRadius() { return me.getBlastRadius(); }
}
